/*
 *	Copyright (C) 2009 Jonathan Naylor, G4KLX
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; version 2 of the License.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */

#if !defined(__DSTARDEFINES_H)
#define	__DSTARDEFINES_H

const bool GMSK_BIT_SYNC[] = {true, false, true, false};
const bool QPSK_BIT_SYNC[] = {true, false, false, true};

const unsigned int GMSK_BIT_RATE = 4800U;
const float        GMSK_BT       = 0.5F;

const bool FRAME_SYNC[]    = {true, true, true, false, true, true, false, false,
							  true, false, true, false, false, false, false};

const bool DATA_SYNC[]     = {true, false, true, false, true, false, true, false,
							  true, false, true, true, false, true, false, false,
							  false, true, true, false, true, false, false, false};

const bool END_PATTERN[]   = {true, false, true, false, true, false, true, false,
							  true, false, true, false, true, false, true, false,
							  true, false, true, false, true, false, true, false,
							  true, false, true, false, true, false, true, false,
							  false, false, false, true, false, false, true, true,
							  false, true, false, true, true, true, true, false};

const unsigned int END_PATTERN_LENGTH = 48U;

const unsigned int VOICE_FRAME_LENGTH_BITS  = 72U;
const unsigned int VOICE_FRAME_LENGTH_BYTES = VOICE_FRAME_LENGTH_BITS / 8U;

const unsigned int DATA_FRAME_LENGTH_BITS   = 24U;
const unsigned int DATA_FRAME_LENGTH_BYTES  = DATA_FRAME_LENGTH_BITS / 8U;

const unsigned int DV_FRAME_LENGTH_BITS     = VOICE_FRAME_LENGTH_BITS + DATA_FRAME_LENGTH_BITS;
const unsigned int DV_FRAME_LENGTH_BYTES    = VOICE_FRAME_LENGTH_BYTES + DATA_FRAME_LENGTH_BYTES;

const unsigned int FEC_SECTION_LENGTH_BITS  = 660U;

const unsigned int RADIO_HEADER_LENGTH_BITS  = 330U;
const unsigned int RADIO_HEADER_LENGTH_BYTES = 41U;

const unsigned int DATA_BLOCK_SIZE_BITS  = 21U * DV_FRAME_LENGTH_BITS;
const unsigned int DATA_BLOCK_SIZE_BYTES = 21U * DV_FRAME_LENGTH_BYTES;

const unsigned int SLOW_DATA_LENGTH_BITS  = 480U;
const unsigned int SLOW_DATA_LENGTH_BYTES = SLOW_DATA_LENGTH_BITS / 8U;

const unsigned char SLOW_DATA_TYPE        = 0x50U;

#endif
