/*
 *	Copyright (C) 2009 Jonathan Naylor, G4KLX
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; version 2 of the License.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */

#if !defined(__DSTARFEC_H)
#define	__DSTARFEC_H

#include "FEC.h"

class CDStarFEC : public IFEC {
public:
	CDStarFEC();
	virtual ~CDStarFEC();

	virtual void encode(const bool* in, bool* out, unsigned int inLen, unsigned int& outLen);
	virtual bool decode(const bool* in, bool* out, unsigned int inLen, unsigned int& outLen);

private:
	bool m_pathMemory0[330];
	bool m_pathMemory1[330];
	bool m_pathMemory2[330];
	bool m_pathMemory3[330];
	int  m_pathMetric[4];

	void acs(unsigned int n, int* metric);
	void viterbiDecode(unsigned int n, int* data);
	void traceBack(bool* out, unsigned int& length);
};

#endif
