/*
 *   Copyright (C) 2002-2004,2006-2009 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#if !defined(__WAVFILEREADER_H)
#define __WAVFILEREADER_H

#include "SoundReader.h"

#include <windows.h>
#include <tchar.h>
#include <mmsystem.h>

enum WAVFORMAT {
        FORMAT_8BIT,
        FORMAT_16BIT,
        FORMAT_32BIT
};


class CWAVFileReader : public ISoundReader {
public:
	CWAVFileReader(TCHAR* fileName);
	~CWAVFileReader();

	virtual bool         open();
	virtual unsigned int read(float* data, unsigned int length);
	virtual void         rewind();
	virtual void         close();

	virtual unsigned int getSampleRate() const;
	virtual unsigned int getChannels() const;

private:
	TCHAR*         m_fileName;
	WAVFORMAT      m_format;
	unsigned int   m_channels;
	unsigned int   m_sampleRate;
	HMMIO          m_handle;
	MMCKINFO       m_parent;
	MMCKINFO       m_child;
	LONG           m_offset;
};

#endif
