/*
 *   Copyright (C) 2002-2004,2006-2009 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#if !defined(__WAVFILEWRITER_H)
#define __WAVFILEWRITER_H

#include "SoundWriter.h"

#include <windows.h>
#include <tchar.h>
#include <mmsystem.h>

class CWAVFileWriter : public ISoundWriter {
public:
	CWAVFileWriter(TCHAR* fileName, unsigned int sampleRate, unsigned int channels, unsigned int sampleWidth);
	virtual ~CWAVFileWriter();

	virtual bool open();
	virtual bool write(const float* buffer, unsigned int length);
	virtual void close();

	virtual unsigned int getSampleRate() const;
	virtual unsigned int getChannels() const;

private:
	TCHAR*       m_fileName;
	unsigned int m_sampleRate;
	unsigned int m_channels;
	unsigned int m_sampleWidth;
	HMMIO        m_handle;
	MMCKINFO     m_parent;
	MMCKINFO     m_child;
};

#endif
